#ifndef __FDTD_H
#define __FDTD_H
#include "matplotpp.h"
#define  PI  3.14159265358979323846
const double	eps0 = (double)8.8541878176203898505365630317164e-12;
const double	miu0 = (double)1.2566370614359172953850573533118e-6;
const double	overc0 = (double)(sqrt(eps0 * miu0));
static const double mu0 = 4 * PI * pow(10.0, -7);
const double	c0 = (double)(1.0 / overc0);
const double imp0 = 120 * PI;
typedef vector<double> field1d;
class FDTD :public MatPlot{ 
public:
	int m_TotalSteps;
	vector<double>m_E;
	vector<double>m_H;
	vector<double>m_grid;
	int m_n;
	double m_dx;
	int qTime;
	double m_dt;
	int m_size;
	int m_outStep;
	int m_total_field_pos;
	FDTD();
	~FDTD(){};
	double m_time;
	int pauseSim;
	void prepare4Run(int n, double dx);
	void updateE();
	void updateH();
	void update();
	//////////////////
	vector<double> m_EzPointSensor;
	void upDateSensor(vector<double>& pointsesor, double value);
	void displayPointSensorData(vector<double>& pointSensor);
	///////////////////
	inline void stepTime();
	void DISPLAY() ;
	bool isRunning()const;
	void togglePause();
	bool simulationFinished()
	{
		if (!m_TotalSteps) return false;
		
		if (qTime<m_TotalSteps+1)
		{
			return false;
		}
		return true;
	};

	void save_snapshot(const char *basename, int frame, field1d& field);
	double source_gauss(int qtime, int delay, int width)
	{
	  return	exp(-((double)qTime - delay) * (qTime - delay) / width);
	}
	double source_gauss_inc(double  mpos, double qtime, int delay, int width)
	{
		return	exp(-(qTime -mpos - delay) * (qTime -mpos - delay) / width);
	}
	void tfst_Update_E(int pos, int qtime);
	void tfsf_Update_H(int pos, int qtime);
};
#endif